'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MonthPickerComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lib = require('../lib');

var _semanticUiReact = require('semantic-ui-react');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function MonthPickerCell(props) {
  var onClick = props.onClick,
      month = props.month;

  var rest = (0, _lib.getUnhandledProps)(MonthPickerCell, props);

  var onMonthClick = function onMonthClick(event) {
    event.stopPropagation();
    onClick(event, _extends({}, props, { value: month }));
  };

  return _react2.default.createElement(
    _semanticUiReact.Table.Cell,
    _extends({}, rest, {
      onClick: onMonthClick,
      className: 'suir-calendar date',
      textAlign: 'center' }),
    month
  );
}

MonthPickerCell.handledProps = ['month', 'onClick'];
function MonthPickerComponent(props) {
  var onMonthClick = props.onMonthClick,
      activeMonth = props.activeMonth,
      isDateDisabled = props.isDateDisabled;


  var cellStyle = {
    width: '33.333333%',
    minWidth: '7em'
  };
  var months = (0, _lib.getMonths)().map(function (month, monthIndex) {
    var monthDisabled = _lodash2.default.isFunction(isDateDisabled) && isDateDisabled({ month: monthIndex });
    return _react2.default.createElement(MonthPickerCell, {
      disabled: monthDisabled,
      style: cellStyle,
      onClick: onMonthClick,
      active: !monthDisabled && month === activeMonth.toString(),
      month: month,
      key: month });
  });
  var rows = _lodash2.default.chunk(months, 3).map(function (row, i) {
    return _react2.default.createElement(
      _semanticUiReact.Table.Row,
      { key: i },
      row
    );
  });
  return _react2.default.createElement(
    _semanticUiReact.Table.Body,
    null,
    rows
  );
}

MonthPickerComponent.handledProps = ['activeMonth', 'isDateDisabled', 'onMonthClick'];
exports.default = MonthPickerComponent;
exports.MonthPickerComponent = MonthPickerComponent;